(***********************************************************************)
(*                                                                     *)
(*                          CamlP3l                                    *)
(*                                                                     *)
(* (C) 2004-2007                                                       *)
(*             Roberto Di Cosmo (dicosmo@dicosmo.org)                  *)
(*             Zheng Li (li@pps.jussieu.fr)                            *)
(*             Pierre Weis (Pierre.Weis@inria.fr)                      *)
(*             Francois Clement (Francois.Clement@inria.fr)            *)
(*                                                                     *)
(* Based on original Ocaml P3L System                                  *)
(* (C) 1997 by                                                         *)
(*             Roberto Di Cosmo (dicosmo@ens.fr)                       *)
(*             Marco Danelutto (marcod@di.unipi.it)                    *)
(*             Xavier Leroy  (Xavier.Leroy@inria.fr)                   *)
(*             Susanna Pelagatti (susanna@di.unipi.it)                 *)
(*                                                                     *)
(* This program is free software; you can redistribute it and/or       *)
(* modify it under the terms of the GNU Library General Public License *)
(* as published by the Free Software Foundation; either version 2      *)
(* of the License, or (at your option) any later version.              *)
(*                                                                     *)
(* This program is distributed in the hope that it will be useful,     *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of      *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       *)
(* GNU Library General Public License for more details.                *)
(*                                                                     *)
(***********************************************************************)

(* $Id: my_data.mli,v 1.2 2007/02/06 15:15:51 fclement Exp $ *)

open Config;;
open Rdec2;;

type subdomain =
    {config_filename : string;
     config : configuration;
     rdec : regular_decomposition;
     num : int;
     iter : int;
     bd : boundary;
     err : float * float};;
(** The type of the components of the array data stream items. In other
   words, the items of the data stream have type [subdomain] array.
   The fields [config_filename], [config] and [rdec] are fixed and unique;
   [num] is fixed and multiple; [iter] is variable and unique;
   [bd] and [errs] are variable and multiple. *)

val get_config_filename : subdomain array -> string;;
val get_config : subdomain array -> configuration;;
val get_rdec : subdomain array -> regular_decomposition;;
val get_nums : subdomain array -> int array;;
val get_iter : subdomain array -> int;;
val get_bds : subdomain array -> boundary array;;
val get_errs : subdomain array -> (float * float) array;;
(** Extraction functions. *)

val set_bds : boundary array -> subdomain array -> unit;;
(** Insertion function. *)
