(* Do not use Unix.open_process as in the following example since...

let plaunch () n =
  let ic, _oc = Unix.open_process (Printf.sprintf "square.sh %d\n" n) in
  let l = input_line ic in
  n, if l = "OK" then 0 else 1;;

with "square.sh" script as follows

#!/bin/sh

case $# in
    1 ) N=$1;;
    * ) echo "KO"; exit 1;;
esac

echo $((N * N)) >&2
echo "OK"
exit 0
*)

let plaunch () =
  let bin = ref None and cout = ref None in
  (fun n ->
    let ib, oc = Uunix.spawn "square_server.sh" bin cout in
    Printf.fprintf oc "%d\n" n;
    flush oc;
    Scanf.bscanf ib "%s\n" (fun l -> n, if l = "OK" then 0 else 1));;

let print_result (n, ier) =
  if ier = 0 then Printf.printf "Execution number %d OK.\n" n else
  Printf.printf "Execution number %d failed.\n" n;;
