(* Testing streams: of_list, to_list, merge. *)
let s1 = Streams.of_list [1; 2; 3];;
let s2 = Streams.of_list [3; 4; 5];;
let s3 = Streams.merge s1 s2;;

let res0 = Streams.to_list s3;;
let good_res0 = [1; 3; 2; 4; 3; 5];;

let s4 = Streams.of_list [1; 3; 5];;
let s5 = Streams.of_list [2; 4];;
let s6 = Streams.merge s4 s5;;

let res1 = Streams.to_list s6;;
let good_res1 =  [1; 2; 3; 4; 5];;

(* Testing skeletons: seq, loop. *)
let s7 = Streams.of_list [3; 7; 10; 14];;
let s8 =
  let p x = x mod 5 <> 0 in
  let f = seq succ in
  loop (p, f) s7;;
let res2 = Streams.to_list s8;;

let good_res2 = [5; 10; 15; 15];;

res0 = good_res0 && res1 = good_res1 && res2 = good_res2;;

let y, n = partition (fun x -> x >= 3) s3;;
to_list y = [3; 4; 3; 5] &&
to_list n = [1; 2];;

merge y n;;
